<?php

namespace Drupal\Tests\media_keepeekdam\Unit;

use Drupal\Core\DependencyInjection\ContainerBuilder;
use Drupal\media_keepeekdam\Service\ClientFactory;
use Drupal\Tests\media_keepeekdam\Traits\KeepeekdamConfigTrait;
use Drupal\Tests\media_keepeekdam\Traits\KeepeekdamLoggerFactoryTrait;
use Drupal\Tests\UnitTestCase;
use GuzzleHttp\Client;

/**
 * Client factory test.
 *
 * @group media_keepeekdam
 */
class KeepeekdamClientFactoryTest extends UnitTestCase {

  use KeepeekdamConfigTrait, KeepeekdamLoggerFactoryTrait;

  /**
   * Container builder helper.
   *
   * @var \Drupal\Core\DependencyInjection\ContainerBuilder
   */
  protected $container;

  /**
   * Media: Keepeek DAM client factory.
   *
   * @var \Drupal\media_keepeekdam\Service\ClientFactory
   */
  protected $clientFactory;

  /**
   * Check to run query.
   */
  public function testGetClient() {
    $client = $this->clientFactory->getClient([]);
    $this->assertInstanceOf(Client::class, $client);
  }

  /**
   * {@inheritdoc}
   */
  public function setUp(): void {
    parent::setUp();

    $this->container = new ContainerBuilder();
    $this->container->set('config.factory', $this->getConfigFactoryStub());
    $this->container->set('logger.factory', $this->getLoggerFactoryStub());
    \Drupal::setContainer($this->container);

    $this->clientFactory = ClientFactory::create($this->container);
  }

}
